<?php
/**
 * CreditCard API Demo 
 * version 1.0
 * 
 * author: Thorsten Kugler 
 * email: tkugler@micropayment.de
 * supported 2009 by micropayment
 */
    
	require_once( 'config.php' );
	require_once( './lib/init.php' );
	require_once( './lib/services/' . MCC__CREDITCARDSERVICE_INTERFACE . '.php' );
	require_once( MCP__SERVICELIB_DISPATCHER . 'TNvpServiceDispatcher.php');  

	
	
//TNvpServiceDispatcher object, CC-API service client, 
	try {
		$dispatcher = new TNvpServiceDispatcher(MCC__CREDITCARDSERVICE_INTERFACE, MCC__CREDITCARDSERVICE_NVP_URL);
	}
	catch ( Exception $e ) {
		print 'TNvpServiceDispatcher error, cannot create instance: '. $e->getMessage();
		exit(0);
	}	


// ermittelt GET-Param oder defaultwert
	function getGetVar($name, $default = '') {
		return isset($_GET[$name]) ? $_GET[$name] : $default;
	}
// ermittelt POST-Param oder defaultwert
	function getPostVar($name, $default = '') {
		return isset($_POST[$name]) ? $_POST[$name] : $default;
	}
// ermittelt SESSION-Variable oder defaultwert
	function getSessionVar($name, $default = '') {
		return isset($_SESSION[$name]) ? $_SESSION[$name] : $default;
	}
// ermittelt SESSION-Variable oder defaultwert
	function setSessionVar($name, $value) {
		$_SESSION[$name] = $value;
	}

	
//set Template vars 
	function getTemplate () {
		$tmp = new Template(func_get_arg(0));
		for ($i = 1; $i < func_num_args(); $i++) {
			$param1 = func_get_arg($i);
			$i += 1;
			$param2 = func_get_arg($i);
			$tmp -> setContent($param1, $param2);
		}
		
		//counter bought products
		$tmp -> setContent('counter1', countProducts());
		//counter products in "shopping bag"
		$tmp -> setContent('counter2', countProductsTmp());
		//is customer guest or logged in?
		$tmp -> setContent('getCustomerName', getCustomerName());	
		print $tmp -> vorlage;
	}
	
	
//products quantity in "shopping bag"
	function countProductsTmp() {
		session_name('creditcard');
		session_start();
		
		$countProductsTmp = 0;
		if (isset($_SESSION['products'])) {
			foreach  ($_SESSION['products'] as $product => $count) {
				$countProductsTmp += $count;
			}
			return "<b>(".$countProductsTmp.")</b>";
		} else {
			return "<b>(0)</b>";;
		}
	}
	

//counter for quantity of products bought (status SUCCESS)
	function countProducts() {
    	
		session_name('creditcard');
		session_start();
		
		try {
			$dispatcher = new TNvpServiceDispatcher(MCC__CREDITCARDSERVICE_INTERFACE, MCC__CREDITCARDSERVICE_NVP_URL);
			
			$sessionData = array();
    		$sessionData = $dispatcher -> sessionList(MCC__ACCESSKEY, MCC__TESTMODE, $_SESSION['customerId']);


			$count_success = 0;
			foreach($sessionData as $tmpdata) {
				$session2Data = $dispatcher -> sessionGet(MCC__ACCESSKEY, MCC__TESTMODE, $tmpdata);
			
    			if ('SUCCESS' == $session2Data['status']) {
    				$count_success += 1;
	    		}
			}
			return '('. $count_success. ')';
		}
		//cannot count, show '?'
		catch( Exception $e ) {
			return '(0)';
		}
	}
	
	
//template class
	class Template {
		
		var $vorlage;
		function Template($vorlage) {
			$this -> setVorlage($vorlage);
		}	

		function setVorlage($vorlage) {
			if(file_exists($vorlage)) {
				$fp = fopen($vorlage, "r");
				$text = fread($fp, filesize($vorlage));
				fclose($fp);
				$this -> vorlage = $text;
			} else {
				$this -> vorlage = $vorlage;
			}
		}

  		function setContent($param1, $param2 = "") {
			$this -> setOne($param1, $param2);
		}

		function setOne($suchWort, $substitution) {
			$this -> vorlage = str_replace("{".$suchWort."}",
			$substitution,
			$this -> vorlage);
		}
  
		function setArray($Array) {
			foreach ($Array as $suchWort => $substitution) {
			$this -> setOne($suchWort, $substitution);
			}
		}

 		function setLoop($schleife, $Array) {
			$str = explode("<!--anfang:".$schleife."!-->",
			str_replace("<!--ende:".$schleife."!-->",
			"<!--anfang:".$schleife."!-->",
			$this -> vorlage));
	
			$teilStr = "";
			foreach ($Array as $element) {
				$teilVorlage = new Template($str[1]);
				$teilVorlage->setArray($element);
				$teilStr .= $teilVorlage->vorlage;
			}
			$this -> vorlage = $str[0] . $teilStr . $str[2];
		}
	}
	
	
//format numbers like x,xx
	function formatAmount($amount) {
		return number_format($amount, 2, ',', '.');
	}

	
//returns CustomerId or guest status
//this isn't sophisticated, but customerCreate in guest mode creates customerIds with length = 40
	function getCustomerName() {

		session_name('creditcard');
		session_start();
		
		if (strlen($_SESSION['customerId']) > 39) {
			return "<em>Gast</em>";
		}
		else {
			return $_SESSION['customerId'];
		}
	}

	
//create year combo (two years past, actuall year, four years future)
	function getYearCombo() {
		
		$sComboYears = "";
    	$tmp_time = time()-63072000;
    	
    	while ($tmp_time <= (time()+126144000)) {
	    	$sComboYears .= "<option>".date("Y",$tmp_time)."</option>";
    		$tmp_time += 31536000;
    	}
    	
    	return $sComboYears;
	}
	
	
//create month combo for creditcard expiry 
	function getMonthCombo() {
		
		$sComboMonths = "";
    	
		for ($i = 1;$i <= 12; $i++) {
    		$sComboMonths .= "<option>".sprintf("%02d",$i)."</option>";
    	}
    	
    	return $sComboMonths;
	}

?>